<template>
  <form action="#" class="rui-search-form" @submit.prevent="$emit('submit')" @reset="buffer = ''">
    <input ref="field"
           v-model="buffer"
           type="search"
           :disabled="disabled"
           :placeholder="placeholder || $t('rui.search.placeholder')">
    <rui-button type="reset"
                :title="$t('rui.input.clear')"
                icon="rui:x-bold" />
    <rui-button v-if="submittable"
                type="submit"
                :title="$t('rui.search.search')"
                icon="rui:magnifying-glass"
                :disabled="disabled" />
  </form>
</template>

<script>
import debounce from 'debounce'
import RuiButton from '../Button/Button.vue'

/**
 * Simple search form with debounced `update` events.
 *
 * **Note** This component depends on the `debounce` library
 *
 * @bindValue "tacos"
 * @disableProps modelValue
 * @propsGroup Display  [submittable]
 * @propsGroup Behavior [disabled]
 * @propsGroup Content  [placeholder]
 */
export default {
  name: 'RuiSearchForm',
  emits: [
    /** Fired on value change */
    'update:modelValue',
    /** Fired when form is submitted. Use it when you don't want to search on every change  */
    'submit',
  ],
  components: { RuiButton },
  props: {
    modelValue: { required: true, type: String },
    /** Whether to disable the inputs */
    disabled: { required: false, type: Boolean, default: false },
    /** Whether to display the search button */
    submittable: { required: false, type: Boolean, default: false },
    /** Custom input placeholder. Defaults to I18n string `rui.search.placeholder` */
    placeholder: { required: false, type: String, default: '' },
  },
  data () {
    return {
      buffer: this.modelValue,
    }
  },
  created () {
    this.$nextTick(() => { this.$refs.field.focus() })
  },
  watch: {
    buffer: debounce(function () {
      if (this.buffer === this.modelValue) return

      this.$emit('update:modelValue', this.buffer)
    }, 250),
    modelValue (newValue) {
      if (newValue !== this.buffer) this.buffer = newValue
    },
  },
}
</script>
